﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace LAB18
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //Globális változók
        Graphics gr, pgr;
        Pen toll = new Pen(Color.Silver, 2);
        SolidBrush ecset = new SolidBrush(Color.Silver);
        Bitmap bm;

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Animáció";
            button1.Text = "Stop";

            //trackbar fel paraméterezése: -30 és +30 fok között mozgat -> 60fok
            trackBar1.Minimum = -30;
            trackBar1.Maximum = 30;

            //időzítés beállítása és indítása
            timer1.Interval = 10 + 150 - trackBar1.Value * 5;
            timer1.Start();

            //az animáció egy bitmap-ben készül
            bm = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            gr = Graphics.FromImage(bm);

        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            Rajz();
        }

        // Sebesség kijelző
        void Rajz()
        {
            //a sebesség kijelzés a panelra készül - gyors mozgatásnál szaggatni fog
            pgr = panel1.CreateGraphics();

            //a folyamatos újrarajzolás miatt mindig törölni kell
            pgr.Clear(System.Drawing.SystemColors.Control);


            toll.Width = 2;
            toll.Color = Color.Blue;

            const float kx = 100;     //középpont x
            const float ky = 210;     //középpont y
            const float n = 200;      //nagy sugár
            const float k = 100;      //kis sugár

            //középpont elmozgatása
            pgr.TranslateTransform(kx, ky);

            //a két körív (-30 és +30fok között)
            pgr.DrawArc(toll, -n, -n, 2 * n, 2 * n, 240, 60);
            pgr.DrawArc(toll, -k, -k, 2 * k, 2 * k, 240, 60);

            //a két oldalsó vonal
            float px = (float)Math.Cos(d2r(60));
            float py = (float)Math.Sin(d2r(60));
            pgr.DrawLine(toll, px * k, -py * k, px * n, -py * n);
            pgr.DrawLine(toll, -px * k, -py * k, -px * n, -py * n);

            //a mutató - a trackbar értéke szerint áll be
            toll.Width = 5;
            toll.Color = Color.Red;
            int szog = trackBar1.Value;
            pgr.RotateTransform(-90 + szog);
            pgr.DrawLine(toll, k, 0, n - 20, 0);

        }

        //Átváltás fokból radiánra a szögfüggvényekhez
        double d2r(double d) { return Math.PI / 180 * d; }

        //Sebesség átállítása a trackbar változtatásakor 
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            timer1.Interval = 10 + 150 - trackBar1.Value * 5;
            Rajz();
        }

        //Dugattyú paraméterek
        double fok = 90;
        int tx = 300;
        int ty = 500;
        int hr = 50;
        int hl = 300;
        int dw = 50;
        int dh = 50;

        // a dugattyú animációja
        // a timer_Tick a timer interval-ban megadott időközönként fut le,
        // ha be van kapcsolva timer Enabled értéke
        private void timer1_Tick(object sender, EventArgs e)
        {
            //törlés
            gr.Clear(System.Drawing.SystemColors.Control);

            //koordináta transzformáció törlése
            gr.ResetTransform();
            //koorináta rendszer eltolása az origóba
            gr.TranslateTransform(tx, ty);
            //y tengely tükrözése
            gr.ScaleTransform(1, -1);

            //elforgatás
            gr.RotateTransform(-30);
            //motor kirajzoltatása
            motor();

            //Egy másik motor megrajzolása ellenütemben
            int fazis = 180;
            fok += fazis;
            gr.RotateTransform(60);
            motor();
            fok -= fazis;

            //léptetés - ez hajtja az animációt
            fok += 5;

            //megjelenítés
            pictureBox1.Image = bm;
        }

        //A motor kirajzolása
        //Az origó a főtengely
        void motor()
        {
            //tengelyek
            toll.Width = 2;
            toll.Color = Color.Silver;
            toll.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDot;
            gr.DrawLine(toll, 0, hr + hl + dh + 20, 0, -2 * hr);  //y
            gr.DrawLine(toll, 2 * hr, 0, -2 * hr, 0);             //x
            gr.DrawEllipse(toll, -hr, -hr, 2 * hr, 2 * hr);       //hajtókar körtengelye

            //főtengely
            toll.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
            toll.Width = 4;
            toll.Color = Color.Black;
            int r = (int)(1.5 * hr);
            gr.DrawEllipse(toll, -r, -r, 2 * r, 2 * r);

            //dugattyúház
            gr.DrawLine(toll, dw, hr + hl + dh, dw, hl - hr);
            gr.DrawLine(toll, -dw, hr + hl + dh, -dw, hl - hr);
            gr.DrawLine(toll, dw, hr + hl + dh, -dw, hr + hl + dh);

            //pontok meghatározása
            float fgx = (float)(Math.Cos(d2r(fok)) * hr);
            float fgy = (float)(Math.Sin(d2r(fok)) * hr);
            float dx = 0;
            float dy = (float)(Math.Sqrt(hl * hl - fgx * fgx) + fgy);

            //hajtókar
            toll.Width = 30;
            gr.DrawLine(toll, fgx, fgy, dx, dy);

            //dugattyú
            toll.Width = 2;
            ecset.Color = Color.Silver;
            gr.FillRectangle(ecset, -dw, dy, 2 * dw, dh);
            gr.DrawRectangle(toll, -dw, dy, 2 * dw, dh);

            //forgattyú
            r = 20;
            gr.FillEllipse(ecset, fgx - r, fgy - r, 2 * r, 2 * r);
            gr.DrawEllipse(toll, fgx - r, fgy - r, 2 * r, 2 * r);

            //felső
            gr.FillEllipse(ecset, dx - r, dy - r, 2 * r, 2 * r);
            gr.DrawEllipse(toll, dx - r, dy - r, 2 * r, 2 * r);
        }

        //A timer indításának és leállításának vezérlése 1 gombbal 
        private void button1_Click(object sender, EventArgs e)
        {
            timer1.Enabled = !timer1.Enabled;
            if (timer1.Enabled) button1.Text = "Stop";
            else button1.Text = "Start";
        }

    }
}
